
# -*- coding: utf-8 -*-
#
# Copyright (c) 2011  <ansuzpeorth@gmail.com>
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the
# Free Software Foundation, Inc., 59 Temple Place - Suite 330,
# Boston, MA 02111-1307, USA.

import os
import os.path
import urllib
import time

from gi.repository import GObject, Gedit

from lib.webkitpanel import WebKitPanel

main_path = os.path.realpath(os.path.dirname(__file__))

class WebkitPanelPlugin(GObject.Object, Gedit.WindowActivatable):
    __gtype_name__ = "WebkitPanelPlugin"
    window = GObject.property(type=Gedit.Window)
    def __init__(self):
        GObject.Object.__init__(self)

    def do_activate(self):
        self._plugin = WebKitPanel(self.window)
        #~FIXME windows icompatible
        diruri = 'file://'+urllib.quote(main_path)+'/www'
        self._plugin.webkit_load_uri(diruri, 'index.html')

    def do_deactivate(self):
        self._plugin.deactivate()

    def update_ui(self):
        self._plugin.update_ui()
        
